<% 
' *
' * Copyright (c) 2006, Dinahosting S.L.
' * All rights reserved.
' * 
' * Redistribution and use in source and binary forms, with or without modification,
' * are permitted provided that the following conditions are met:
' * 
' *     * Redistributions of source code must retain the above copyright notice, this
' *       list of conditions and the following disclaimer.
' *     * Redistributions in binary form must reproduce the above copyright notice,
' *       this list of conditions and the following disclaimer in the documentation
' *       and/or other materials provided with the distribution.
' *     * Neither the name of the Dinahosting S.L. nor the names of its contributors
' *       may be used to endorse or promote products derived from this software
' *       without specific prior written permission.
' * 
' * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
' * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
' * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
' * IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
' * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
' * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
' * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
' * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
' * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
' * OF THE POSSIBILITY OF SUCH DAMAGE.
' */

Response.Expires = -1
Response.Buffer=True 

Dim Errores()
Dim usuario, password

'/**
' * url a la que se envian las peticiones.
' */
DINAHOSTING_URL_ENVIO = "https://apisms.gestiondecuenta.com/php/comun/ejecutarComando.php"

'/**
' * Para ayudar al depurado.
' */
DINAHOSTING_SMS_DEBUG=True


    ' **
    ' * Establece el remitente.
    ' *
    ' */
Sub DHsmsDHSender(cuenta,password)
	usuario=cuenta
	password=password
End Sub

    ' **
    ' * Obtiene el crdito restante
    ' * devuelve:
	' *			|->entero
    ' */
Function DHgetCredito() 
	Dim i, xmlTXT, num_errores
	
	xmlTXT=ObtenerXML("cuenta=" & usuario & "&password=" & password & "&command=sms_getCredit")

	'errores
	num_errores=ParsearXML (xmlTXT, "interface-response", "ErrCount")

	'OK
	if num_errores=0 then
		DHgetCredito=ParsearXML (xmlTXT, "interface-response", "smsCredit")
	else
	'KO
		Redim Preserve Errores(num_errores)
		for i=1 to num_errores
			Errores(i)=ParsearXML (xmlTXT,"interface-response/errors", "Err" & i)
		next 
		DHgetCredito=false
	end if
end function

    ' **
    ' * Enva un sms a 1 destinatario.
    ' * parmetros:
	' *			|->numero: string
	' *			|->mensaje: string
    ' * devuelve:
	' *			|->boolean
    ' */
Function DHSend(numero,mensaje,remite) 
	Dim i, xmlTXT, num_errores, parametros
	
	If remite<>"" Then
		parametros="cuenta=" & usuario & "&password=" & password & "&command=sms_send&" & "&sms=" & mensaje & "&sms_to=" & numero  & "&remite=" & remite
	Else
		parametros="cuenta=" & usuario & "&password=" & password & "&command=sms_send&" & "&sms=" & mensaje & "&sms_to=" & numero
	End if

	xmlTXT=ObtenerXML(parametros)
	
	'errores
	num_errores=ParsearXML (xmlTXT, "interface-response", "ErrCount")

	'OK
	if num_errores=0 then
		DHSend=True
	else
	'KO
		Redim Preserve Errores(num_errores)
		for i=1 to num_errores
			Errores(i)=ParsearXML (xmlTXT,"interface-response/errors", "Err" & i)
		next 
		DHSend=false
	end if
end function

    ' **
    ' * Enva un sms a varios destinatarios.
    ' * parmetros:
	' *			|->numero: array  
	' *			|->mensaje: string
    ' * devuelve:
	' *			|->boolean
    ' */
Function DHSendBulk(numero,mensaje) 
	Dim i, xmlTXT, num_errores
	Dim m_POST

	m_POST = "cuenta=" & usuario & "&password=" & password & "&command=sms_sendBulk" & "&sms=" & mensaje 

	For i = LBound(numero) To UBound(numero)
        m_POST = m_POST & "&sms_to[" & i + 1 & "]=" & numero(i)
    Next
	m_POST = m_POST & "&sms_n_msgs=" & i

	xmlTXT=ObtenerXML(m_POST)

	'errores
	num_errores=ParsearXML (xmlTXT, "interface-response", "ErrCount")

	'OK
	if num_errores=0 then
		DHSendBulk=True
	else
	'KO
		Redim Preserve Errores(num_errores)
		for i=1 to num_errores
			Errores(i)=ParsearXML (xmlTXT,"interface-response/errors", "Err" & i)
		next 
		DHSendBulk=false
	end if
end function

    ' **
    ' * Realiza la peticin remota.
    ' */
Function ObtenerXML(parametros)
	Dim MyConnection, TheURL
		
	' Especifica la URL
	TheURL = DINAHOSTING_URL_ENVIO
		
	 Set MyConnection = Server.CreateObject("MSXML2.ServerXMLHTTP")

	 MyConnection.setOption 2, 13056

     if DINAHOSTING_SMS_DEBUG then
		response.write "POST " & DINAHOSTING_URL_ENVIO & "<BR>"
        response.write "Post data: '" & parametros & "'" & "<BR>"
     end if

	' Conexin
	MyConnection.Open "POST", TheURL, False
	MyConnection.setRequestHeader "Accept-Language", "sp"
	MyConnection.setRequestHeader "Pragma", "no-cache"
	MyConnection.SetRequestHeader "charset", "iso-8859-1" 
	MyConnection.setRequestHeader "Content-Type", "application/x-www-form-urlencoded"	
	' Enviar y obtener datos

	MyConnection.Send parametros
	TheData = MyConnection.responseText

	if DINAHOSTING_SMS_DEBUG then
		response.write "Respuesta: " & server.HTMLEncode(TheData) & "<BR>"
    end if

	'Establecer Content-Type
	Response.ContentType = MyConnection.getResponseHeader("Content-Type")
	ObtenerXML=TheData

	Set MyConnection = Nothing
End Function

    ' **
    ' * parsea XML
    ' */
Function ParsearXML(XML,nodo,valor) 
	Set xmldoc = Server.CreateObject("Microsoft.XMLDOM")
	xmldoc.loadXML XML
	set valor_nodo = xmldoc.selectsingleNode (nodo & "/" & valor)
	ParsearXML=valor_nodo.Text
	set xmldoc=nothing
	set valor_nodo=nothing
End Function
%>
